/*
===============================================================================
 Name        : LPCNano.c
 Author      : $(author)
 Version     :
 Copyright   : $(copyright)
 Description : main definition
===============================================================================
*/

#include <cr_section_macros.h>
#include "system8xx.h"

//---------------------------------------------------------------------
struct {
	int32_t tick;
	int32_t startup;
	int32_t procRun;
	uint32_t lifetime;
}system;

COMMAND_STRUCT_T commandResponse;
void CommandExe(COMMAND_STRUCT_T *pCommandStruct, COMMAND_STRUCT_T *pCommandResponse);

//---------------------------------------------------------------------
int main(void) {

	System8xxInit();
	LedsInit();
	SerialDebugInit();
	MyDelayInit();
	StorageInit();

	system.startup = 300;
	system.procRun = 0;
	LedsSet(1, LEDS_STAY_ON);

	SystemSysTickInit(MAIN_DELAY);

	while(1) {

		//-------------------------------------
		do {
			if (SerialDebugCommandCheck() > 0){
				LedsSet(1, 2);
				CommandExe(SerialDebugCommandGet(), &commandResponse);

				SerialDebugMessage("DBG>>");
				CommandManShow(SerialDebugCommandGet(), commandList);
				//SerialDebugMessage("RESP>>");
				//CommandManShow(&commandResponse, commandList);
			}

			if (SerialDebugProcess()){
				LedsSet(1, 2);
			}

		} while (SystemSysTickCheck() == 0);



		//-------------------------------------
		if (system.startup > 0){
			system.startup--;

			if (system.startup == 200){
				SerialDebugMessage("LPCnano, based on LPC824");
				SerialDebugMessage("ep@prolab.waw.pl");
			}

			if (system.startup == 0){
				SystemInitEnd();
				LedsSet(1, 0);
				system.procRun = 1;
			}
		}



		//-------------------------------------
		if (system.procRun > 0){

			//-------------------------------------------------------------------------
			//tick
			if (system.tick < (2000/MAIN_DELAY)){
				system.tick++;

			} else {
				system.tick = 0;
				LedsSet(1, 1);
				system.lifetime++;
				SerialDebugAddParam("\rTick:", system.lifetime);
			}

		} else {

			//if system paused
		}

    	//-------------------------------------------------------------------------
		LedsProc();
	}
    return 0 ;
}


//-----------------------------------------------------------------------------------
void CommandExe(COMMAND_STRUCT_T *pCommandStruct, COMMAND_STRUCT_T *pCommandResponse){
	int16_t index = pCommandStruct->index;

	switch (index){
		case 1:{
			SerialDebugMessage("Hello :)\r");
		} break;

		case 2:{

		} break;

		case 3:{

		} break;

		default:{
			SerialDebugMessage("command not supported");
		}
	}
}
