/*
 * flashStorage.h
 *
 *  Created on: 14.01.2019
 *      Author: Procesorowiec
 */

#ifndef SETT_FLASHSTORAGE_H_
#define SETT_FLASHSTORAGE_H_


void StorageBuffSrcSet(uint32_t *buffSrc);
void StorageInit(void);
void StorageFill(void);
void StorageValAdd(int16_t data, int16_t adr);
void StorageManyValAdd(int16_t *data, int16_t len, int16_t adr);
int16_t StorageValGet(int16_t adr);
void StorageManyValGet(int16_t *dst, int16_t len, int16_t adr);
void StorageNeedUpdateSet(void);
int16_t StorageProc(void);
void StorageSave(void);





/* IAP command definitions */
#define FLASHSTORAGE_PREWRRITE_CMD           50	/*!< Prepare sector for write operation command */
#define FLASHSTORAGE_WRISECTOR_CMD          51	/*!< Write Sector command */
#define FLASHSTORAGE_ERSSECTOR_CMD           52	/*!< Erase Sector command */
#define FLASHSTORAGE_BLANK_CHECK_SECTOR_CMD  53	/*!< Blank check sector */


/* IAP response definitions */
#define FLASHSTORAGE_CMD_SUCCESS             0	/*!< Command is executed successfully */
#define FLASHSTORAGE_INVALID_COMMAND         1	/*!< Invalid command */
#define FLASHSTORAGE_SRC_ADDR_ERROR          2	/*!< Source address is not on word boundary */
#define FLASHSTORAGE_DST_ADDR_ERROR          3	/*!< Destination address is not on a correct boundary */
//#define IAP_SRC_ADDR_NOT_MAPPED     4	/*!< Source address is not mapped in the memory map */
//#define IAP_DST_ADDR_NOT_MAPPED     5	/*!< Destination address is not mapped in the memory map */
//#define IAP_COUNT_ERROR             6	/*!< Byte count is not multiple of 4 or is not a permitted value */
//#define IAP_INVALID_SECTOR          7	/*!< Sector number is invalid or end sector number is greater than start sector number */
//#define IAP_SECTOR_NOT_BLANK        8	/*!< Sector is not blank */
//#define IAP_SECTOR_NOT_PREPARED     9	/*!< Command to prepare sector for write operation was not executed */
//#define IAP_COMPARE_ERROR           10	/*!< Source and destination data not equal */
//#define IAP_BUSY                    11	/*!< Flash programming hardware interface is busy */
//#define IAP_PARAM_ERROR             12	/*!< nsufficient number of parameters or invalid parameter */
//#define IAP_ADDR_ERROR              13	/*!< Address is not on word boundary */
//#define IAP_ADDR_NOT_MAPPED         14	/*!< Address is not mapped in the memory map */
//#define IAP_CMD_LOCKED              15	/*!< Command is locked */
//#define IAP_INVALID_CODE            16	/*!< Unlock code is invalid */
//#define IAP_INVALID_BAUD_RATE       17	/*!< Invalid baud rate setting */
//#define IAP_INVALID_STOP_BIT        18	/*!< Invalid stop bit setting */
//#define IAP_CRP_ENABLED             19	/*!< Code read protection enabled */


#endif /* SETT_FLASHSTORAGE_H_ */
