/*
 * serial8xx.h
 *
 *  Created on: 26.08.2018
 *      Author: Procesorowiec
 */

#ifndef BASE_SERIAL15XX_H_
#define BASE_SERIAL15XX_H_

#include "stringBuilder.h"
#include "commandMan.h"

void SerialInit(LPC_USART_T *pUART);
void SerialDataConfig(LPC_USART_T *pUART);
void SerialBaudSet(LPC_USART_T *pUART, uint32_t baudrate);
void SerialEnable(LPC_USART_T *pUART);
void SerialTXEnable(LPC_USART_T *pUART);
void SerialTenPinEnable(LPC_USART_T *pUART);

void SerialSend(LPC_USART_T *pUART, uint8_t data);
uint8_t SerialReadGet(LPC_USART_T *pUART);
uint32_t SerialStatusGet(LPC_USART_T *pUART);

void SerialReadIntEnable(LPC_USART_T *pUART);
void SerialSendIntEnable(LPC_USART_T *pUART);
void SerialSendIdleIntEnable(LPC_USART_T *pUART);
void SerialReadIntDisable(LPC_USART_T *pUART);
void SerialSendIntDisable(LPC_USART_T *pUART);
void SerialSendIdleIntDisable(LPC_USART_T *pUART);

void SerialIrqHandler(LPC_USART_T *pUART, STRINGBUFF_T *txStringBuff, STRINGBUFF_T *rxStringBuff);
void SerialIrqHandlerBlockMode(LPC_USART_T *pUART, STRINGBUFF_T *txStringBuff,  STRINGBUFF_T *rxStringBuff);
void SerialIrqHandlerCommandMode(LPC_USART_T *pUART, STRINGBUFF_T *txStringBuff,  COMMAND_REC_BUFF_T *rxCommandBuff);

void SerialSendHolding(LPC_USART_T *pUART, uint8_t *src);
void SerialSendStringBuffHolding(LPC_USART_T *pUART, STRINGBUFF_T *txStringBuff);

#endif /* BASE_SERIAL15XX_H_ */
