/*
 * stringBuilder.h
 *
 *  Created on: 25.08.2018
 *      Author: Procesorowiec
 */

#ifndef BASE_STRINGBUILDER_H_
#define BASE_STRINGBUILDER_H_

typedef struct {
	uint8_t *base;
	uint16_t len;
	volatile int16_t i;
	volatile int16_t track;
	uint8_t *pt;

} STRINGBUFF_T;

void StringBuilderStringInit(STRINGBUFF_T *pStringBuff, uint8_t *buff, uint16_t len);
uint8_t StringBuilderClear(STRINGBUFF_T *pStringBuff);
void StringBuilderMasterClear(STRINGBUFF_T *pStringBuff);
uint8_t StringBuilderCheck(STRINGBUFF_T *pStringBuff);
uint8_t StringBuilderTrackCheck(STRINGBUFF_T *pStringBuff);
uint8_t StringBuilderTrackHomeCheck(STRINGBUFF_T *pStringBuff);
int16_t StringBuilderActualLenGet(STRINGBUFF_T *pStringBuff);
void StringBuilderTrackSet(STRINGBUFF_T *pStringBuff, int16_t track);
uint8_t *StringBuilderGet(STRINGBUFF_T *pStringBuff);
uint8_t StringBuilderAddChar(STRINGBUFF_T *pStringBuff, uint8_t data);

void StringBuilderAddString(STRINGBUFF_T *pStringBuff, uint8_t *src);
uint32_t StringBuilderAddVal(STRINGBUFF_T *pStringBuff, int32_t val);
void StringBuilderAddValWlen(STRINGBUFF_T *pStringBuff, int32_t val, uint8_t len, uint8_t emptyChar);
void StringBuilderAddValWdot(STRINGBUFF_T *pStringBuff, int32_t val, uint16_t dotPos);

void StringBuilderAddHexVal(STRINGBUFF_T *pStringBuff, uint8_t val);
void StringBuilderAddHex32Val(STRINGBUFF_T *pStringBuff, int32_t val);

#endif /* BASE_STRINGBUILDER_H_ */
