/*
 * system8xx.h
 *
 *  Created on: Feb 23, 2018
 *      Author: dsosnowski
 */

#ifndef BASE_SYSTEM8XX_H_
#define BASE_SYSTEM8XX_H_


#include "chip.h"
#include "system8xx.h"
#include "leds.h"
#include "serial8xx.h"
#include "serialDebug.h"
#include "mydelay8xx.h"
#include "flashStorage.h"
#include "stringParser.h"

#define MAIN_CLOCK		30000000
#define PREMAIN_CLOCK	60000000

#define MAIN_DELAY		10


typedef struct {
	uint32_t port;
	uint32_t pin;
	//CHIP_IOCON_PIO_T ioconPin;
}PIN_STRUCT_T;

typedef struct {
	uint8_t port;
	uint8_t pin;
	uint16_t iocon;
	uint8_t output;
	uint8_t active;
	uint8_t idle;
}PINEX_STRUCT_T;

#define PIN_OUTPUT_EN			1
#define PIN_INPUT				0

#define IOCON_MODE_INACT		(0 << 3)
#define IOCON_MODE_PULLDOWN		(1 << 3)
#define IOCON_MODE_PULLUP		(2 << 3)

#define IOCON_HYS_ENABLE		(1 << 5)
#define IOCON_HYS_DISABLE		(0 << 5)

#define IOCON_OD_ENABLE			(1 << 10)
#define IOCON_OD_DISABLE		(0 << 10)

#define IOCON_FILTER_3CYCLE		(3 << 11)

#define IOCON_CLKDIV0			(0 << 13)
#define IOCON_CLKDIV1			(1 << 13)
#define IOCON_CLKDIV2			(2 << 13)
#define IOCON_CLKDIV3			(3 << 13)
#define IOCON_CLKDIV4			(4 << 13)
#define IOCON_CLKDIV5			(5 << 13)
#define IOCON_CLKDIV6			(6 << 13)


void System8xxInit(void);
void SystemPeripInit(void);
void SystemInitEnd(void);

void SystemSysTickInit(uint32_t intervalMs);
uint8_t SystemSysTickCheck(void);

void IoMaskedValueSet(LPC_GPIO_T *pGPIO, uint8_t port, uint32_t mask, uint32_t val);
void IoConPinMuxSet(LPC_IOCON_T *pIOCON, uint8_t port, uint8_t pin, uint32_t modefunc);
void SystemPortInit(PINEX_STRUCT_T *portArray, int32_t len);

#endif /* BASE_SYSTEM8XX_H_ */
