/*
 * commandMan.c
 *
 *  Created on: 01.10.2018
 *      Author: Procesorowiec
 */


/*
 * commandRec.c
 *
 *  Created on: 30.08.2018
 *      Author: Procesorowiec
 */




#include "system8xx.h"
#include "stringBuilder.h"
#include "commandMan.h"
#include "stringParser.h"

//setters
const uint8_t cNameHello[] = "Hello\0";


COMMAND_NAME_T commandList[] = {
		{1, cNameHello},
		{0,0}
};


//-----------------------------------------------------------------------------------
void CommandManInit(COMMAND_REC_BUFF_T *pCommandBuff, uint8_t *buff, uint16_t len, uint8_t prefix, uint8_t postfix){
	pCommandBuff->base = buff;
	pCommandBuff->pt = pCommandBuff->base;
	pCommandBuff->i = 0;
	pCommandBuff->len = len;
	pCommandBuff->track = 0;
	pCommandBuff->prefix = prefix;
	pCommandBuff->postfix = postfix;
	pCommandBuff->status = 0;
}

//-----------------------------------------------------------------------------------
void CommandManAdd(COMMAND_REC_BUFF_T *pCommandBuff, uint8_t data){
	if (pCommandBuff->status < 2){
		if (data == pCommandBuff->prefix){
			pCommandBuff->status = 1;
			pCommandBuff->i = 0;
		}
		if (pCommandBuff->status == 1){
			if (pCommandBuff->i < (pCommandBuff->len - 2)){
				pCommandBuff->pt = (pCommandBuff->base + pCommandBuff->i);
				*pCommandBuff->pt = data;
				pCommandBuff->pt++;
				*pCommandBuff->pt = 0;
				pCommandBuff->i++;
			}
		}
		if (data == pCommandBuff->postfix){
			if (pCommandBuff->status == 1){
				pCommandBuff->status = 2;
			}
		}
	}
}

//-----------------------------------------------------------------------------------
uint8_t CommandManCheck(COMMAND_REC_BUFF_T *pCommandBuff){
	if (pCommandBuff->status == 2){
		return 1;
	}
	return 0;
}

//-----------------------------------------------------------------------------------
void CommandManClear(COMMAND_REC_BUFF_T *pCommandBuff){
	pCommandBuff->pt = pCommandBuff->base;
	pCommandBuff->i = 0;
	pCommandBuff->status = 0;
}



//i.e. #Time=12;45;30\n\r
//i.e. #Time?\n\r

//-----------------------------------------------------------------------------------
int16_t CommandManDecode(COMMAND_REC_BUFF_T *pCommandBuff, COMMAND_STRUCT_T *pCommandStruct){
	int16_t endset = pCommandBuff->i;
	uint8_t *src = pCommandBuff->base;
	int16_t i;
	int16_t i2;
	int16_t val;

	int16_t cListIndex = 0;
	int16_t commandIndex = commandList[cListIndex].index;

	pCommandStruct->index = 0;
	pCommandStruct->numParam = 0;

	while (commandIndex > 0){

		i = StrIndexOfStringGet(src, commandList[cListIndex].srcName, 0, endset);
		if (i > -1){

			i = StrIndexOfLettersEndGet(src, i, endset);
			if (i > -1){
				pCommandStruct->action = StrCharAtIndexGet(src, i);
				if ((pCommandStruct->action != COMMAND_SET) &&
					(pCommandStruct->action != COMMAND_NEED)){
					pCommandStruct->action = 0;
				}

				// = ------------------------------------------------
				//if (pCommandStruct->action == COMMAND_SET){
					StrTextCopy(src, i+1, pCommandStruct->txt, 16, 0);

					if (StrTypeValueCheck(src, i+1) > 0){
						val = StrValueGet(src, i+1);

						i2 = StrIndexOfNumbersEndGet(src, i+1, endset);
						if (i2 > -1){
							pCommandStruct->par1 = val;
							pCommandStruct->numParam++;
							i = i2;
						}
					}
					if (StrTypeValueCheck(src, i+1) > 0){
						val = StrValueGet(src, i+1);

						i2 = StrIndexOfNumbersEndGet(src, i+1, endset);
						if (i > -1){
							pCommandStruct->par2 = val;
							pCommandStruct->numParam++;
							i = i2;
						}
					}
					if (StrTypeValueCheck(src, i+1) > 0){
						val = StrValueGet(src, i+1);

						i2 = StrIndexOfNumbersEndGet(src, i+1, endset);
						if (i > -1){
							pCommandStruct->par3 = val;
							pCommandStruct->numParam++;
							i = i2;
						}
					}
					if (StrTypeValueCheck(src, i+1) > 0){
						val = StrValueGet(src, i+1);

						i2 = StrIndexOfNumbersEndGet(src, i+1, endset);
						if (i > -1){
							pCommandStruct->par4 = val;
							pCommandStruct->numParam++;
							i = i2;
						}
					}
				//}

				// ? ------------------------------------------------
				//if (pCommandStruct->action == COMMAND_RETURN){
				//	i++;
				//}

				// \n ------------------------------------------------
				if (StrCharAtIndexGet(src, i) == COMMAND_POSTFIX){
				//if (StrCharAtIndexGet(src, i) == COMMAND_ENDCHAR){
					// \r ------------------------------------------------
					//if (StrCharAtIndexGet(src, i+1) == COMMAND_POSTFIX){
						pCommandStruct->index = commandIndex;
					//}
				}
			}
		}

		if (pCommandStruct->index > 0){
			break;
		}

		cListIndex++;
		commandIndex = commandList[cListIndex].index;
	}
	return pCommandStruct->index;
}

//--------------------------------------------------------------------
void CommandManShow(COMMAND_STRUCT_T *pCommandStruct, COMMAND_NAME_T *nameList){
	SerialDebugMessage("COMM:");
    SerialDebugAddVal(pCommandStruct->index);
	SerialDebugAdd("  ");

	if (pCommandStruct->index > 0){
		int16_t i = pCommandStruct->index - 1;
		SerialDebugAdd(nameList[i].srcName);

		SerialDebugAddChar(pCommandStruct->action);

		if (pCommandStruct->numParam > 0){
			SerialDebugAddChar('(');
			SerialDebugAddVal(pCommandStruct->numParam);
			SerialDebugAdd(") ");
			SerialDebugAddVal(pCommandStruct->par1);

			if (pCommandStruct->numParam > 1){
				SerialDebugAddChar(';');
				SerialDebugAddVal(pCommandStruct->par2);
			}
			if (pCommandStruct->numParam > 2){
				SerialDebugAddChar(';');
				SerialDebugAddVal(pCommandStruct->par3);
			}
			if (pCommandStruct->numParam > 3){
				SerialDebugAddChar(';');
				SerialDebugAddVal(pCommandStruct->par4);
			}
		}
		if (pCommandStruct->txt[0] > 0){
			SerialDebugAdd(" TXT: ");
			SerialDebugAdd(pCommandStruct->txt);
		}
		SerialDebugAdd("\r");
	}
}

//-----------------------------------------------------------------------------------
void CommandManExe(COMMAND_STRUCT_T *pCommandStruct){
	int16_t index = pCommandStruct->index;

	switch (index){
		case 1:{

		} break;

		case 2:{

		} break;

		case 3:{

		} break;

		case 4:{

		} break;

		case 5:{

		} break;

		case 6:{

		} break;
	}
}


#define SETT_STRLEN				20

/*
//------------------------------------------------------------------
int16_t GetManFrameCheck(STRINGBUFF_T *src){
	int16_t result = GETMAN_NOTREADY;
	int16_t pos;
	int16_t offset;
	int16_t endset;

	offset = src->track;
	endset = src->i;
	if (endset > 5){
		pos = StrIndexOfStringGet(src->base, "GET /?", offset, endset);
		if (pos >= 0){
			offset = pos;
			result = GETMAN_PARAMS;
		}
	}
	return result;
}
*/
/*
//i.e. - GET /?tStart=8%3A00&tStop=22%3A00&cOn=5&cOff=30 HTTP/1.1
//------------------------------------------------------------------
int16_t GetManCommandScan(STRINGBUFF_T *src, COMMAND_STRUCT_T *cmd){
	int16_t offset;
	int16_t endset;
	int16_t pos;
	int16_t i;
	int16_t commandIndex;
	int16_t scan;

		scan = HTTP_COMM_ERR;
		offset = src->track;
		endset = src->i;

		pos = StrIndexOfCharGet(src->base, '?', 1, offset, endset);
		if (pos >= 0) {
			pos++;
			offset = pos;
		} else {
			pos = StrIndexOfCharGet(src->base, '&', 1, offset, endset);
			if (pos > 0) {
				pos++;
				offset = pos;
			} else {

			}
		}

		if (pos > 0) {		//if offset success

			pos = StrIndexOfCharGet(src->base, '&', 1, offset, endset);
			if (pos > 0) {
				endset = pos;
			} else {

				pos = StrIndexOfCharGet(src->base, '\r', 1, offset, endset);
				if (pos > 0) {
					endset = pos;

				}
			}
		}




		if ((pos > 0) && (offset < endset)){
			//SerialDebugAddParam("*off*", offset);
			//SerialDebugAddParam("*end*", endset);
			//endset = pos;
			//if (offset < endset){
			//SerialDebugAddParam(" offset:", offset);
			//SerialDebugAddParam(" endset:", endset);
			cmd->index = 0;
			cmd->action = 0;
			cmd->numParam = 0;

			i = 0;
			scan = 1;
			while (scan == 1){

				commandIndex = httpCommandList[i].index;
				if (commandIndex > 0){
					pos = StrIndexOfStringGet(src->base, httpCommandList[i].srcName, offset, endset);
					if (pos > 0){	//find command offset

						cmd->index = commandIndex;
						scan = HTTP_COMM_OK;		//find command, scan end

						pos = StrIndexOfCharGet(src->base, '=', 1, offset, endset);
						if (pos > 0){	//find param offset

							cmd->action = '=';
							offset = (pos+1);
							if (StrCharAtIndexGet(src->base, offset) == ' ') offset+=1;

							StrTextCopy(src->base, offset, cmd->txt, SETT_STRLEN, 0);

							if (StrTypeValueCheck(src->base, offset) > 0){	//find some value
								cmd->numParam = 1;
								cmd->par1 = StrValueGet(src->base, offset);	//get value

								pos = StrIndexOfNumbersEndGet(src->base, offset, endset);	//find end of value
								if (StrCharAtIndexGet(src->base, pos) == '%') pos += 2;
								offset = (pos + 1);
								if (StrCharAtIndexGet(src->base, offset) == ' ') offset+=1;
							}

							if (StrTypeValueCheck(src->base, offset) > 0){	//find some value
								cmd->numParam = 2;
								cmd->par2 = StrValueGet(src->base, offset);	//get value

								pos = StrIndexOfNumbersEndGet(src->base, offset, endset);	//find end of value
								if (StrCharAtIndexGet(src->base, pos) == '%') pos += 2;
								offset = (pos + 1);
								if (StrCharAtIndexGet(src->base, offset) == ' ') offset+=1;
							}
							if (StrTypeValueCheck(src->base, offset) > 0){	//find some value
								cmd->numParam = 3;
								cmd->par3 = StrValueGet(src->base, offset);	//get value

								pos = StrIndexOfNumbersEndGet(src->base, offset, endset);	//find end of value
								if (StrCharAtIndexGet(src->base, pos) == '%') pos += 2;
								offset = (pos + 1);
								if (StrCharAtIndexGet(src->base, offset) == ' ') offset+=1;
							}
							if (StrTypeValueCheck(src->base, offset) > 0){	//find some value
								cmd->numParam = 4;
								cmd->par4 = StrValueGet(src->base, offset);	//get value

								pos = StrIndexOfNumbersEndGet(src->base, offset, endset);	//find end of value
								if (StrCharAtIndexGet(src->base, pos) == '%') pos += 2;
								offset = (pos + 1);
							}

						} else {	//not find param offset, so not find value
							//scan = 1;
							//i++;
							cmd->action = '?';
							cmd->numParam = 0;
						}
					} else {	//not find this command, check next
						i++;
					}
				} else {	//end of commands table
					scan = HTTP_COMM_ERR;
				}

			}	//sec while

			//SerialDebugAddParam("*END*", endset);
			src->track = endset;

		} else {	//pos > 0
			scan = HTTP_COMM_ERR;
		}
	return scan;
}
*/



