/*
 * commandMan.h
 *
 *  Created on: 01.10.2018
 *      Author: Procesorowiec
 */

#ifndef COMM_COMMANDMAN_H_
#define COMM_COMMANDMAN_H_

#define COMMAND_PREFIX		'#'
#define COMMAND_SET			'='
#define COMMAND_NEED		'?'
#define COMMAND_RETURN		':'
//#define COMMAND_ENDCHAR		'\r'
#define COMMAND_POSTFIX		'\r'


typedef struct {
	uint8_t *base;
	uint16_t len;
	volatile int16_t i;
	volatile int16_t track;
	uint8_t *pt;
	volatile uint8_t status;
	uint8_t prefix;
	uint8_t postfix;
} COMMAND_REC_BUFF_T;

typedef struct {
	uint8_t index;
	uint8_t *srcName;
} COMMAND_NAME_T;

typedef struct {
	int16_t index;
	int16_t action;
	int16_t numParam;
	int16_t par1;
	int16_t par2;
	int16_t par3;
	int16_t par4;
	int8_t txt[32];
} COMMAND_STRUCT_T;

extern COMMAND_NAME_T commandList[];

void CommandManInit(COMMAND_REC_BUFF_T *pCommandBuff, uint8_t *buff, uint16_t len, uint8_t prefix, uint8_t postfix);
void CommandManAdd(COMMAND_REC_BUFF_T *pCommandBuff, uint8_t data);
uint8_t CommandManCheck(COMMAND_REC_BUFF_T *pCommandBuff);
void CommandManClear(COMMAND_REC_BUFF_T *pCommandBuff);

int16_t CommandManDecode(COMMAND_REC_BUFF_T *pCommandBuff, COMMAND_STRUCT_T *pCommandStruct);
void CommandManShow(COMMAND_STRUCT_T *pCommandStruct, COMMAND_NAME_T *nameList);
void CommandManExe(COMMAND_STRUCT_T *pCommandStruct);

#endif /* COMM_COMMANDMAN_H_ */
