/*
 * stringParser.c
 *
 *  Created on: 23.09.2018
 *      Author: Procesorowiec
 */

#include "system8xx.h"
#include "stringParser.h"


#define SP_CHARACTER_START			'+'
#define SP_CHARACTER_END			'z'


//-----------------------------------------------------------------------------------
int16_t StrIndexOfStringGet(uint8_t *src, uint8_t *find, int16_t offset, int16_t endset){
	int16_t i = offset;
	uint8_t *pt;
	uint8_t *cmp;
	int16_t result = -1;

	while (i < endset){
		pt = src + i;
		cmp = find;
		result = -1;

		while (*cmp > 0){
			if (*pt == *cmp){
				pt++;
				cmp++;
				result = i;
			} else {
				result = -1;
				break;
			}
		}

		if (result > -1){
			break;
		}

		i++;
	}
	return result;
}

//-----------------------------------------------------------------------------------
int16_t StrIndexOfCharGet(uint8_t *src, uint8_t findChar, uint8_t count, int16_t offset, int16_t endset){
	int16_t i = offset;
	uint8_t *pt;
	int16_t result = -1;

	while (i < endset){
		pt = src + i;

		if (*pt == findChar){
			if (count > 0){
				count--;
				if (count == 0){
					result = i;
				}
			}
		}

		if (result > -1){
			break;
		}

		i++;
	}
	return result;
}

//-----------------------------------------------------------------------------------
int16_t StrIndexOfLettersEndGet(uint8_t *src, int16_t offset, int16_t endset){
	int16_t i = offset;
	uint8_t *pt;
	int16_t result = -1;
	pt = src + offset;

	while (i < endset){
		/*if(		((*pt >= 'A') && (*pt<= 'Z')) ||
				((*pt >= 'a') && (*pt <= 'z')) ||
				((*pt >= '0') && (*pt <= '9')) ||
				(*pt == '_') ||
				(*pt == '-')
		){*/
		if((*pt >= SP_CHARACTER_START) && (*pt <= SP_CHARACTER_END)){
			pt++;
			i++;
		} else {
			result = i;
			break;
		}
	}
	return result;
}

//-----------------------------------------------------------------------------------
uint8_t StrCharAtIndexGet(uint8_t *src, int16_t index){
	return *(src+index);
}

//-----------------------------------------------------------------------------------
void StrCharAtIndexSet(uint8_t *src, int16_t index, uint8_t newChar){
	*(src+index) = newChar;
}

//-----------------------------------------------------------------------------------
void StrFill(uint8_t *src, uint8_t data, int16_t offset, int16_t endset){
	int16_t i = offset;
	uint8_t *pt;
	pt = src + offset;

	while (i < endset){
		*pt = data;
		pt++;
		i++;
	}
}

//-----------------------------------------------------------------------------------
int16_t StrValueGet(uint8_t *src, int16_t offset){
	uint8_t *pt;
	int16_t result = 0;
	int16_t minus = 1;
	int16_t val;

	pt = src + offset;

	if (*pt == '-'){
		minus = -1;
		pt++;
	}

	while  ((*pt >= '0') && (*pt <= '9')){
		val = (*pt - '0');
		result *= 10;
		result += val;
		pt++;
	}

	return (result * minus);
}

//-----------------------------------------------------------------------------------
uint8_t StrTypeValueCheck(uint8_t *src, int16_t offset){
	uint8_t *pt;
	pt = src + offset;

	if (*pt == '-'){
		pt++;
	}
	if  ((*pt >= '0') && (*pt <= '9')){
		return 1;
	}
	return 0;
}

//-----------------------------------------------------------------------------------
int16_t StrIndexOfNumbersEndGet(uint8_t *src, int16_t offset, int16_t endset){
	int16_t i = offset;
	uint8_t *pt;
	int16_t result = -1;
	pt = src + offset;

	while (i < endset){
		if(((*pt >= '0') && (*pt <= '9')) || (*pt == '-')){
			pt++;
			i++;
		} else {
			result = i;
			break;
		}
	}
	return result;
}

//-----------------------------------------------------------------------------------
int16_t StrTextCopy(uint8_t *src, int16_t offset, uint8_t *dst, int16_t len, uint8_t endChar){
	int16_t i = 0;
	uint8_t newChar;
	uint8_t *pt;
	pt = src + offset;

	while (i<(len-1)){
		if  ((*pt >= SP_CHARACTER_START) && (*pt <= SP_CHARACTER_END)){
			if (*pt != endChar){
				*dst = *pt;
				dst++;
				pt++;
				i++;
			} else {
				break;
			}
		} else {
			break;
		}
	}
	*dst = 0;
	return i;
}
